/*-
 * Copyright (C)2000, 2001, 2002 @BABOLO http://www.links.ru/~babolo/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: getCGIparm.h,v 1.1 2003/01/27 03:55:11 babolo Exp $
 */

#define DOER   0x0001   /* Error indicate when parameter not found */
#define MATC   0x0002   /* Non-matching result is error            */
#define NONL   0x0004   /* Empty result string is error            */
#define ERRMASK 0x007
#define ZERO   0x0008   /* Empty parameter will be substituted     */
#define NOCR   0x0010   /* Delete CR on output                     */
#define NOLF   0x0020   /* Delete LF on output                     */
#define OTST   0x0040   /* No output - test only                   */
#define HOVR   0x0100   /* Hack ON - use SERVER_PROTOCOL           */
#define RTRY   0x0200   /* Retry if empty parameter found          */
#define OPEN   0x8000   /* tofind on pass4 has * at end            */
#define VERB 0x010000   /* Verbose                                 */
#define VERM 0x020000   /* Verbose more                            */

enum states {d0, d1, d2, v0, v1, v2, vx, dx};
/* d0 -   
   d1 -    - %,  1 
   d2 -  2    
   v0 -  
   v1 -    - %,  1 
   v2 -  2    
   vx -  .
   dx -  
 */

enum classes {no, ok, pc, am, eq, pl, hd, hx, hX, nl, xx};
/* no  
   ok ,    
   pc %
   am &
   eq =
   pl +
   hd  
   hx   
   hX   
   nl \0
   xx
 */

struct patterns
{   u_char *name;
    int namelen;
    int (*test_proc)(u_char *pattern, u_char *query);
};

struct quotens
{   u_char *name;
    int namelen;
    int (*test_proc)(u_char *pattern, u_char *query, u_char **result);
};

extern u_char *empty;

int pass1 __P((u_int32_t, u_char **, u_char *, u_char *));
int pass2 __P((u_int32_t, u_char *, u_char *));
int pass3 __P((u_int32_t, u_char *, u_char **));
void pass4 __P((u_int32_t, u_char *, u_char *, u_char *, u_char *, u_char *));

extern struct patterns patterns[];
extern struct quotens quotens[];
extern u_int32_t automa[xx][dx];
