/* 
   Copyright (C) 2000 David Rysdam
   CGIed by .@babolo.ru using getCGIparm (C)2003

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See COPYING for details.
*/

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) 2000 David Rysdam (C)2000, 2001, 2002 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: sendCGImail.cgi.c,v 1.3 2003/01/27 04:37:14 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sysexits.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <fcntl.h>
#include <stdio.h>
#include "getCGIparm.h"

u_char *myname, *errmsg, *errfile, *errform, *quot, *zero;
u_int32_t flags;
u_char *query_delimit;
u_char *empty = "";

/*
  Algorithm:
  
  1) Email to send will be received on stdin
  2) Open defined host and port number
  3) Send mail out port with SMTP protocol as:
     a) HELO defined domain
     b) MAIL FROM: defined sender (from MUA?)
     c) RCPT TO: to header from MUA
     d) DATA
     e) mail file
     d) <CRLF>.<CRLF>

*/

#define BUF_SIZE 64
#define MAX_MSG_LEN 1024*5
#define MAX_RCPTS 8
#define MAX_RCPT_ADDR_LEN 128
#define RCFILE "/etc/sendCGImail.rc"

char *host=NULL;
char *fromaddr=NULL;
char *domain=NULL;
char *rcpts=NULL;;
char *subj=NULL;;
int port=0;
int debug_level=0;
FILE *stdlog;

//yes, I realize this is ugly AND stupid--but do you have a better idea?
char crlf_buffer[MAX_MSG_LEN*2+1];
int more_data=1;

int send_mail(u_char *);
int get_socket(void);
void strif(u_char *, off_t *, off_t);
typedef unsigned long ulong;

void
strif(u_char *conf, off_t *cc, off_t st_size) {
    while (*cc < st_size - 1 && conf[*cc] != '\n') (*cc)++;
    conf[(*cc)++] = '\0';
};

int
main(int argc, char *argv[]) {
    int confd;
    u_char *conf;
    off_t c;
    struct stat sb;
#define INBUF 1048576
    u_char *query = getenv("QUERY_STRING");
    u_char *proto = getenv("SERVER_PROTOCOL");
    u_char *unescaped, *p, *q;
    int i, j, ex = EX_OK, sillyloop;
#ifdef DEBUG
# if DEBUG > 1
    for (i = no; i < xx; i++)
    {   for (j = d0; j < dx; j++) printf(" %08X", automa[i][j]);
        printf("\n");
    }
# endif
    debug_level = DEBUG;
    stdlog = stderr;
#endif
    flags = 0;
    quot = NULL;
    errmsg = NULL;
    errfile = NULL;
    myname = *argv;
    query_delimit = "\n";
    if  (!query) query = "";
    unescaped = malloc(strlen(query) * (query_delimit ? strlen(query_delimit) : 1) + 1);
    if  (!unescaped)                                           err(EX_TEMPFAIL, "%s: malloc:", myname);
    p = unescaped;
    i = 0;

    for (;;)
    {   ex = pass1(flags, &query, NULL, p);
        if  (!ex && *query++ == '&')
        {   if  (query_delimit)
                p = index(strcat(unescaped, query_delimit), '\0');
            else if (flags & RTRY && !*unescaped) i++;
            else break;
        }else break;
    }

    if  (ex && i)
    {   *unescaped = '\0';
        ex = EX_OK;
    }

    if  (!ex)
    {   ex = pass2(flags, "any", unescaped);
        if  (!ex)
        {   ex = pass3(flags, quot, &unescaped);
            if  (!ex && flags & NONL && !*unescaped) ex = EX_DATAERR;
        }else if (~flags & MATC)
        {   *unescaped = '\0';
            ex = EX_OK;
        }
    }else if (~flags & DOER) ex = EX_OK;

    if  (ex)                                                                                  exit(ex);

    confd = open(RCFILE, O_RDONLY);
    if  (fstat(confd, &sb))                                                           exit(EX_DATAERR);
    conf = mmap(NULL, sb.st_size, PROT_READ|PROT_WRITE, MAP_PRIVATE, confd, 0);
    close(confd);
    c = 0;

    while (c < sb.st_size) {
        switch (conf[c++]) {
        case 'h':
            host = &conf[c];
            strif(conf, &c, sb.st_size);
            break;
        case 'd':
            domain = &conf[c];
            strif(conf, &c, sb.st_size);
            break;
        case 'f':
            fromaddr = &conf[c];
            strif(conf, &c, sb.st_size);
            break;
        case 'p':
            port = atoi(&conf[c]);
            strif(conf, &c, sb.st_size);
            break;
        case 's':
            subj = &conf[c];
            strif(conf, &c, sb.st_size);
            break;
        case 't':
            rcpts = &conf[c];
            strif(conf, &c, sb.st_size);
            break;
        default:
            strif(conf, &c, sb.st_size);
    }   }

    if  (domain == NULL || fromaddr == NULL || host == NULL || rcpts == NULL) exit(EX_USAGE);
    if  (port == 0) port = 25;

    if  (debug_level) {
        fprintf(stdlog, "Running with options:\n");
        fprintf(stdlog, "\thost = %s\n", host);
        fprintf(stdlog, "\tport = %d\n", port);
        fprintf(stdlog, "\trcpts = %s\n", rcpts);
        if  (subj) fprintf(stdlog, "\tsubj = %s\n", subj);
        fprintf(stdlog, "\tdebuglevel = %d\n", debug_level);
    }

    if  (send_mail(unescaped)) {
        if  (debug_level) fprintf(stdlog, "Error in send_mail\n");
        exit(EX_DATAERR);
    }
    printf("Content-type: text/plain\n\nDone\n");
    exit(EX_OK);
}

void
make_crlf(u_char *unescaped) {
    int i,j;

    memset(crlf_buffer, 0, MAX_MSG_LEN * 2 + 1);

    //crlf_buffer is twice the size of buffer,
    //so even if the entire message was \n's, I won't
    //overflow the new buffer.  TODO: Make this a 
    //little smarter

    for (i = j = 0; i < MAX_MSG_LEN; i++, j++) {
        if  (unescaped[i] == '\n' && unescaped[i - 1] != '\r')
        crlf_buffer[j++] = '\r';
        crlf_buffer[j] = unescaped[i];
}   }

/*
  open socket to host/port
  send data as described above
*/

int
send_mail(u_char *unescaped) {
    int i;
    int sock;
    char local_in_buf[BUF_SIZE];
    //*2 to hold the crlf_buffer
    char local_out_buf[MAX_MSG_LEN*2+1];
    int num_bytes;

    if((sock = get_socket()) < 0)                                                            return(1);

    memset(local_in_buf, 0, BUF_SIZE);

    while (num_bytes = read(sock, local_in_buf, BUF_SIZE - 1)) {
        if  (debug_level) fprintf(stdlog, "%s", local_in_buf);
        if  ((num_bytes < BUF_SIZE-1) || (local_in_buf[BUF_SIZE-2] == '\n')) break;
        memset(local_in_buf, 0, BUF_SIZE);
    }  

    snprintf(local_out_buf, strlen(domain)+8, "HELO %s\r\n", domain);
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                              return(1);

    while (num_bytes = read(sock, local_in_buf, BUF_SIZE - 1)) {
        if  (debug_level) fprintf(stdlog, "%s", local_in_buf);
        if  ((num_bytes < BUF_SIZE - 1) || (local_in_buf[BUF_SIZE - 2] == '\n')) break;
        memset(local_in_buf, 0, BUF_SIZE);
    }  

    snprintf(local_out_buf, strlen(fromaddr) + 16, "MAIL FROM: <%s>\r\n", fromaddr);
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                              return(1);
  
    while (num_bytes = read(sock, local_in_buf, BUF_SIZE - 1)) {
        if  (debug_level) fprintf(stdlog, "%s", local_in_buf);
        if  ((num_bytes < BUF_SIZE - 1) || (local_in_buf[BUF_SIZE - 2] == '\n')) break;
        memset(local_in_buf, 0, BUF_SIZE);
    } 

    snprintf(local_out_buf, strlen(rcpts) + 14, "RCPT TO: <%s>\r\n", rcpts);
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1) return 1;

    while (num_bytes = read(sock, local_in_buf, BUF_SIZE - 1)) {
        if  (debug_level) fprintf(stdlog, "%s", local_in_buf);
        if  ((num_bytes < BUF_SIZE - 1) || (local_in_buf[BUF_SIZE - 2] == '\n')) break;
        memset(local_in_buf, 0, BUF_SIZE);
    }  

    snprintf(local_out_buf, 7, "DATA\r\n");
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                              return(1);
  
    while (num_bytes = read(sock, local_in_buf, BUF_SIZE - 1)) {
        if  (debug_level) fprintf(stdlog, "%s", local_in_buf);
        if  ((num_bytes < BUF_SIZE - 1) || (local_in_buf[BUF_SIZE - 2] == '\n')) break;
        memset(local_in_buf, 0, BUF_SIZE);
    } 

    if  (subj) {
        snprintf(local_out_buf, MAX_MSG_LEN, "Subject: %s\r\n\r\n", subj);
        if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                          return(1);
    }

    //send any additional data
    make_crlf(unescaped);
    snprintf(local_out_buf, strlen(crlf_buffer) + 1, "%s", crlf_buffer);
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                              return(1);
							   
    snprintf(local_out_buf, 6, "\r\n.\r\n");
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                              return(1);
  
    while (num_bytes = read(sock, local_in_buf, BUF_SIZE - 1)) {
        if  (debug_level) fprintf(stdlog, "%s", local_in_buf);
        if  ((num_bytes < BUF_SIZE-1) || (local_in_buf[BUF_SIZE - 2] == '\n')) break;
        memset(local_in_buf, 0, BUF_SIZE);
    } 

    snprintf(local_out_buf, 7, "QUIT\r\n");
    if  (write(sock, local_out_buf, strlen(local_out_buf)) < 1)                              return(1);
  
    return(0);
}

/* 
   lookup hostname
   open defined port on host
   return socket
*/
int
get_socket(void) {
    struct hostent *servp;
    int sockfd;
    struct sockaddr_in addr;

    servp = gethostbyname(host);
    if(servp == NULL)                                                                        return(0);

    if  (debug_level){
        fprintf(stdlog, "got name: %s\n", servp->h_name);
        fprintf(stdlog, "got IP: %s\n", inet_ntoa(*((struct in_addr *)servp->h_addr)));
    }  

    if  (debug_level > 1) {
        sockfd = STDOUT_FILENO;
        return(sockfd); 
    } else {
        if  ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1)                               return(0);
        bzero(&addr, sizeof(addr));
        addr.sin_family = AF_INET;
        addr.sin_port = htons(port);
        addr.sin_addr = *((struct in_addr *)servp->h_addr);
        if (connect(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr)) == -1)        return(0);
        return sockfd;
}   }
